# Ipopt::WsmpSolverInterface Class Reference

Interface to the linear solver Wsmp, derived from SparseSymLinearSolverInterface. More...

`#include <IpWsmpSolverInterface.hpp>`

Inheritance diagram for Ipopt::WsmpSolverInterface:
[legend]

List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
virtual bool | ProvidesDegeneracyDetection () const
| Query whether the indices of linearly dependent rows/columns can be determined by this linear solver.
virtual ESymSolverStatus | DetermineDependentRows (const Index *ia, const Index *ja, std::list< Index > &c_deps)
| This method determines the list of row indices of the linearly dependent rows.
Constructor/Destructor
| WsmpSolverInterface ()
| Constructor.
virtual | ~WsmpSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *ia, const Index *ja)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements are to be stored.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *ia, const Index *ja, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| WsmpSolverInterface (const WsmpSolverInterface &)
| Copy Constructor.
void | operator= (const WsmpSolverInterface &)
| Overloaded Equals Operator.
Internal functions
ESymSolverStatus | SymbolicFactorization (const Index *ia, const Index *ja)
| Call Wsmp to do the analysis phase.
ESymSolverStatus | InternalSymFact (const Index *ia, const Index *ja, Index numberOfNegEVals)
| Call Wsmp to really do the analysis phase.
ESymSolverStatus | Factorization (const Index *ia, const Index *ja, bool check_NegEVals, Index numberOfNegEVals)
| Call Wsmp to factorize the Matrix.
ESymSolverStatus | Solve (const Index *ia, const Index *ja, Index nrhs, double *rhs_vals)
| Call Wsmpx to do the Solve.
## Private Attributes
Index | matrix_file_number_
| Counter for matrix file numbers.
Information about the matrix
Index | dim_
| Number of rows and columns of the matrix.
Index | nonzeros_
| Number of nonzeros of the matrix in triplet representation.
double * | a_
| Array for storing the values of the matrix.
Solver specific options
Index | wsmp_num_threads_
| Option that controls the matching strategy.
Number | wsmp_pivtol_
| Pivol tolerance.
Number | wsmp_pivtolmax_
| Maximal pivot tolerance.
Index | wsmp_scaling_
| Indicating which of WSMP's scaling methods should be used.
Number | wsmp_singularity_threshold_
| WSMP's singularity threshold.
Index | wsmp_write_matrix_iteration_
| iteration number in which matrices are to be written out
bool | skip_inertia_check_
| Flag indicating if the interia is always assumed to be correct.
bool | wsmp_no_pivoting_
| Flag indicating whether the positive definite version of WSMP should be used.
Information about most recent factorization/solve
Index | negevals_
| Number of negative eigenvalues.
Initialization flags
bool | initialized_
| Flag indicating if internal data is initialized.
bool | printed_num_threads_
| Flag indicating if we already printed how many threads are used by WSMP.
bool | pivtol_changed_
| Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed, or the computation of the ordering has been triggered with DPARNM[14].
bool | have_symbolic_factorization_
| Flag indicating whether symbolic factorization and order has already been performed.
Index | factorizations_since_recomputed_ordering_
| Counter indicating how many factorizations have been done sine the last recomputation of the ordering.
Solver specific information
ipfint * | IPARM_
| Integer parameter array for WSSMP.
double * | DPARM_
| Double precision parameter array for WSSMP.
ipfint * | PERM_
| WSSMP's permutation vector.
ipfint * | INVP_
| WSSMP's inverse permutation vector.
ipfint * | MRP_
| WSSMP's internal MRP array.
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for IpoptType.

## Detailed Description

Interface to the linear solver Wsmp, derived from SparseSymLinearSolverInterface.

For details, see description of SparseSymLinearSolverInterface base class.

Definition at line 24 of file IpWsmpSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::WsmpSolverInterface::WsmpSolverInterface | ( |  | ) |

Constructor.

virtual Ipopt::WsmpSolverInterface::~WsmpSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::WsmpSolverInterface::WsmpSolverInterface | ( | const WsmpSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::WsmpSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::WsmpSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::WsmpSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements are to be stored.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::WsmpSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::WsmpSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::WsmpSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::WsmpSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 76 of file IpWsmpSolverInterface.hpp.

EMatrixFormat Ipopt::WsmpSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 83 of file IpWsmpSolverInterface.hpp.

static void Ipopt::WsmpSolverInterface::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for IpoptType.

virtual bool Ipopt::WsmpSolverInterface::ProvidesDegeneracyDetection | ( |  | ) | const`[virtual]`

Query whether the indices of linearly dependent rows/columns can be determined by this linear solver.

Reimplemented from Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::WsmpSolverInterface::DetermineDependentRows | ( | const Index * | ia,
|  | const Index * | ja,
|  | std::list< Index > & | c_deps |
| ) |  |  | `[virtual]`

This method determines the list of row indices of the linearly dependent rows.

Reimplemented from Ipopt::SparseSymLinearSolverInterface.

void Ipopt::WsmpSolverInterface::operator= | ( | const WsmpSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::AlgorithmStrategyObject.

ESymSolverStatus Ipopt::WsmpSolverInterface::SymbolicFactorization | ( | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[private]`

Call Wsmp to do the analysis phase.

ESymSolverStatus Ipopt::WsmpSolverInterface::InternalSymFact | ( | const Index * | ia,
|  | const Index * | ja,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call Wsmp to really do the analysis phase.

ESymSolverStatus Ipopt::WsmpSolverInterface::Factorization | ( | const Index * | ia,
|  | const Index * | ja,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call Wsmp to factorize the Matrix.

ESymSolverStatus Ipopt::WsmpSolverInterface::Solve | ( | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call Wsmpx to do the Solve.

## Member Data Documentation

Index Ipopt::WsmpSolverInterface::dim_`[private]`

Number of rows and columns of the matrix.

Definition at line 123 of file IpWsmpSolverInterface.hpp.

Index Ipopt::WsmpSolverInterface::nonzeros_`[private]`

Number of nonzeros of the matrix in triplet representation.

Definition at line 126 of file IpWsmpSolverInterface.hpp.

double* Ipopt::WsmpSolverInterface::a_`[private]`

Array for storing the values of the matrix.

Definition at line 129 of file IpWsmpSolverInterface.hpp.

Index Ipopt::WsmpSolverInterface::wsmp_num_threads_`[private]`

Option that controls the matching strategy.

Definition at line 149 of file IpWsmpSolverInterface.hpp.

Number Ipopt::WsmpSolverInterface::wsmp_pivtol_`[private]`

Pivol tolerance.

Definition at line 151 of file IpWsmpSolverInterface.hpp.

Number Ipopt::WsmpSolverInterface::wsmp_pivtolmax_`[private]`

Maximal pivot tolerance.

Definition at line 153 of file IpWsmpSolverInterface.hpp.

Index Ipopt::WsmpSolverInterface::wsmp_scaling_`[private]`

Indicating which of WSMP's scaling methods should be used.

Definition at line 155 of file IpWsmpSolverInterface.hpp.

Number Ipopt::WsmpSolverInterface::wsmp_singularity_threshold_`[private]`

WSMP's singularity threshold.

The smaller this value the less likely a matrix is declared singular.

Definition at line 158 of file IpWsmpSolverInterface.hpp.

Index Ipopt::WsmpSolverInterface::wsmp_write_matrix_iteration_`[private]`

iteration number in which matrices are to be written out

Definition at line 160 of file IpWsmpSolverInterface.hpp.

bool Ipopt::WsmpSolverInterface::skip_inertia_check_`[private]`

Flag indicating if the interia is always assumed to be correct.

Definition at line 163 of file IpWsmpSolverInterface.hpp.

bool Ipopt::WsmpSolverInterface::wsmp_no_pivoting_`[private]`

Flag indicating whether the positive definite version of WSMP should be used.

Definition at line 166 of file IpWsmpSolverInterface.hpp.

Index Ipopt::WsmpSolverInterface::matrix_file_number_`[private]`

Counter for matrix file numbers.

Definition at line 170 of file IpWsmpSolverInterface.hpp.

Index Ipopt::WsmpSolverInterface::negevals_`[private]`

Number of negative eigenvalues.

Definition at line 175 of file IpWsmpSolverInterface.hpp.

bool Ipopt::WsmpSolverInterface::initialized_`[private]`

Flag indicating if internal data is initialized.

For initialization, this object needs to have seen a matrix

Definition at line 182 of file IpWsmpSolverInterface.hpp.

bool Ipopt::WsmpSolverInterface::printed_num_threads_`[private]`

Flag indicating if we already printed how many threads are used by WSMP.

Definition at line 185 of file IpWsmpSolverInterface.hpp.

bool Ipopt::WsmpSolverInterface::pivtol_changed_`[private]`

Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed, or the computation of the ordering has been triggered with DPARNM[14].

Definition at line 189 of file IpWsmpSolverInterface.hpp.

bool Ipopt::WsmpSolverInterface::have_symbolic_factorization_`[private]`

Flag indicating whether symbolic factorization and order has already been performed.

Definition at line 192 of file IpWsmpSolverInterface.hpp.

Index Ipopt::WsmpSolverInterface::factorizations_since_recomputed_ordering_`[private]`

Counter indicating how many factorizations have been done sine the last recomputation of the ordering.

Definition at line 195 of file IpWsmpSolverInterface.hpp.

ipfint* Ipopt::WsmpSolverInterface::IPARM_`[private]`

Integer parameter array for WSSMP.

Definition at line 201 of file IpWsmpSolverInterface.hpp.

double* Ipopt::WsmpSolverInterface::DPARM_`[private]`

Double precision parameter array for WSSMP.

Definition at line 203 of file IpWsmpSolverInterface.hpp.

ipfint* Ipopt::WsmpSolverInterface::PERM_`[private]`

WSSMP's permutation vector.

Definition at line 205 of file IpWsmpSolverInterface.hpp.

ipfint* Ipopt::WsmpSolverInterface::INVP_`[private]`

WSSMP's inverse permutation vector.

Definition at line 207 of file IpWsmpSolverInterface.hpp.

ipfint* Ipopt::WsmpSolverInterface::MRP_`[private]`

WSSMP's internal MRP array.

Definition at line 209 of file IpWsmpSolverInterface.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/LinearSolvers/IpWsmpSolverInterface.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines